<?php

declare(strict_types=1);

namespace App\Repository;

final class TblPublicidadXUsuarioRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblPublicidadXUsuarioId): object
    {
        $query = 'SELECT * FROM `TblPublicidadXUsuario` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblPublicidadXUsuarioId);
        $statement->execute();
        $TblPublicidadXUsuario = $statement->fetchObject();
        if (! $TblPublicidadXUsuario) {
            throw new \Exception('TblPublicidadXUsuario not found.', 404);
        }

        return $TblPublicidadXUsuario;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblPublicidadXUsuario` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblPublicidadXUsuario): object
    {
        $query = 'INSERT INTO `TblPublicidadXUsuario` (`IdPublicidad`, `Estado`, `IdUsuario`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:IdPublicidad, :Estado, :IdUsuario, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblPublicidadXUsuario->id);
//         $statement->bindParam('fecha', $TblPublicidadXUsuario->fecha);
        $statement->bindParam('IdPublicidad', $TblPublicidadXUsuario->IdPublicidad);
        $statement->bindParam('Estado', $TblPublicidadXUsuario->Estado);
        $statement->bindParam('IdUsuario', $TblPublicidadXUsuario->IdUsuario);
        $statement->bindParam('field1', $TblPublicidadXUsuario->field1);
        $statement->bindParam('field2', $TblPublicidadXUsuario->field2);
        $statement->bindParam('field3', $TblPublicidadXUsuario->field3);
        $statement->bindParam('field4', $TblPublicidadXUsuario->field4);
        $statement->bindParam('field5', $TblPublicidadXUsuario->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblPublicidadXUsuario, object $data): object
    {
        if (isset($data->fecha)) {
            $TblPublicidadXUsuario->fecha = $data->fecha;
        }
        if (isset($data->IdPublicidad)) {
            $TblPublicidadXUsuario->IdPublicidad = $data->IdPublicidad;
        }
        if (isset($data->Estado)) {
            $TblPublicidadXUsuario->Estado = $data->Estado;
        }
        if (isset($data->IdUsuario)) {
            $TblPublicidadXUsuario->IdUsuario = $data->IdUsuario;
        }
        if (isset($data->field1)) {
            $TblPublicidadXUsuario->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblPublicidadXUsuario->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblPublicidadXUsuario->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblPublicidadXUsuario->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblPublicidadXUsuario->field5 = $data->field5;
        }

        $query = 'UPDATE `TblPublicidadXUsuario` SET `fecha` = :fecha, `IdPublicidad` = :IdPublicidad, `Estado` = :Estado, `IdUsuario` = :IdUsuario, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblPublicidadXUsuario->id);
        $statement->bindParam('fecha', $TblPublicidadXUsuario->fecha);
        $statement->bindParam('IdPublicidad', $TblPublicidadXUsuario->IdPublicidad);
        $statement->bindParam('Estado', $TblPublicidadXUsuario->Estado);
        $statement->bindParam('IdUsuario', $TblPublicidadXUsuario->IdUsuario);
        $statement->bindParam('field1', $TblPublicidadXUsuario->field1);
        $statement->bindParam('field2', $TblPublicidadXUsuario->field2);
        $statement->bindParam('field3', $TblPublicidadXUsuario->field3);
        $statement->bindParam('field4', $TblPublicidadXUsuario->field4);
        $statement->bindParam('field5', $TblPublicidadXUsuario->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblPublicidadXUsuario->id);
    }

    public function delete(int $TblPublicidadXUsuarioId): void
    {
        $query = 'DELETE FROM `TblPublicidadXUsuario` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblPublicidadXUsuarioId);
        $statement->execute();
    }
}
